var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import * as React from "react";

import { FacetFilterProps, FacetFilterPropTypes, FacetAccessor, SearchkitComponent, ISizeOption, FastClick, renderComponent, FieldOptions, CheckboxItemList, Panel } from "searchkit";

import { SignFacetAccessor } from "./SignFacetAccessor";

import { defaults } from "lodash";
import { identity } from "lodash";

export var SignFacetFilter = (_temp = _class = function (_SearchkitComponent) {
    _inherits(SignFacetFilter, _SearchkitComponent);

    function SignFacetFilter(props) {
        _classCallCheck(this, SignFacetFilter);

        var _this = _possibleConstructorReturn(this, _SearchkitComponent.call(this, props));

        _this.toggleViewMoreOption = _this.toggleViewMoreOption.bind(_this);
        return _this;
    }

    SignFacetFilter.prototype.getAccessorOptions = function getAccessorOptions() {
        var _props = this.props,
            field = _props.field,
            id = _props.id,
            operator = _props.operator,
            title = _props.title,
            include = _props.include,
            exclude = _props.exclude,
            size = _props.size,
            translations = _props.translations,
            orderKey = _props.orderKey,
            orderDirection = _props.orderDirection,
            fieldOptions = _props.fieldOptions;

        return {
            id: id, operator: operator, title: title, size: size, include: include, exclude: exclude, field: field,
            translations: translations, orderKey: orderKey, orderDirection: orderDirection, fieldOptions: fieldOptions
        };
    };

    SignFacetFilter.prototype.defineAccessor = function defineAccessor() {
        return new SignFacetAccessor(this.props.field, this.getAccessorOptions());
    };

    SignFacetFilter.prototype.defineBEMBlocks = function defineBEMBlocks() {
        var blockName = this.props.mod || "sk-refinement-list";
        return {
            container: blockName,
            option: blockName + "-option"
        };
    };

    SignFacetFilter.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
        if (prevProps.operator != this.props.operator) {
            this.accessor.options.operator = this.props.operator;
            this.searchkit.performSearch();
        }
    };

    SignFacetFilter.prototype.toggleFilter = function toggleFilter(key) {
        this.accessor.state = this.accessor.state.toggle(key);
        this.searchkit.performSearch();
    };

    SignFacetFilter.prototype.setFilters = function setFilters(keys) {
        this.accessor.state = this.accessor.state.setValue(keys);
        this.searchkit.performSearch();
    };

    SignFacetFilter.prototype.toggleViewMoreOption = function toggleViewMoreOption(option) {
        this.accessor.setViewMoreOption(option);
        this.searchkit.performSearch();
    };

    SignFacetFilter.prototype.hasOptions = function hasOptions() {
        return this.accessor.getBuckets().length != 0;
    };

    SignFacetFilter.prototype.getSelectedItems = function getSelectedItems() {
        return this.accessor.state.getValue();
    };

    SignFacetFilter.prototype.getItems = function getItems() {
        return this.props.bucketsTransform(this.accessor.getBuckets());
    };

    SignFacetFilter.prototype.render = function render() {
        var _props2 = this.props,
            listComponent = _props2.listComponent,
            containerComponent = _props2.containerComponent,
            showCount = _props2.showCount,
            title = _props2.title,
            id = _props2.id,
            countFormatter = _props2.countFormatter;

        return renderComponent(containerComponent, {
            title: title,
            className: id ? "filter--" + id : undefined,
            disabled: !this.hasOptions()
        }, [renderComponent(listComponent, {
            key: "listComponent",
            items: this.getItems(),
            itemComponent: this.props.itemComponent,
            selectedItems: this.getSelectedItems(),
            toggleItem: this.toggleFilter.bind(this),
            setItems: this.setFilters.bind(this),
            docCount: this.accessor.getDocCount(),
            showCount: showCount,
            translate: this.translate,
            countFormatter: countFormatter
        }), this.renderShowMore()]);
    };

    SignFacetFilter.prototype.renderShowMore = function renderShowMore() {
        var _this2 = this;

        var option = this.accessor.getMoreSizeOption();

        if (!option || !this.props.showMore) {
            return null;
        }

        return React.createElement(
            FastClick,
            { handler: function handler() {
                    return _this2.toggleViewMoreOption(option);
                }, key: "showMore" },
            React.createElement(
                "div",
                { "data-qa": "show-more", className: this.bemBlocks.container("view-more-action") },
                this.translate(option.label)
            )
        );
    };

    return SignFacetFilter;
}(SearchkitComponent), _class.propTypes = FacetFilterPropTypes, _class.defaultProps = {
    listComponent: CheckboxItemList,
    containerComponent: Panel,
    size: 50,
    collapsable: false,
    showCount: true,
    showMore: true,
    bucketsTransform: identity
}, _temp);