var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import * as React from "react";
import * as PropTypes from "prop-types";

import { SearchkitComponent, SearchkitComponentProps, NestedFacetAccessor, FacetAccessor, HierarchicalFacetAccessor, ReactComponentType, renderComponent, Panel, FacetFilterPropTypes, CheckboxItemList, ISizeOption, FastClick, FieldOptions } from "searchkit";

import { SignTermsAccessor } from "./SignTermsAccessor";

var defaults = require("lodash/defaults");
var identity = require("lodash/identity");
var max = require("lodash/max");
var map = require("lodash/map");
var maxBy = require("lodash/maxBy");
var get = require("lodash/get");

export var SignTermsFilter = (_temp = _class = function (_SearchkitComponent) {
	_inherits(SignTermsFilter, _SearchkitComponent);

	function SignTermsFilter() {
		_classCallCheck(this, SignTermsFilter);

		return _possibleConstructorReturn(this, _SearchkitComponent.apply(this, arguments));
	}

	SignTermsFilter.prototype.defineBEMBlocks = function defineBEMBlocks() {
		var blockClass = this.props.mod || "sk-hierarchical-menu";
		return {
			container: blockClass + "-list",
			option: blockClass + "-option"
		};
	};

	SignTermsFilter.prototype.defineAccessor = function defineAccessor() {
		var _props = this.props,
		    id = _props.id,
		    title = _props.title,
		    fields = _props.fields,
		    size = _props.size,
		    orderKey = _props.orderKey,
		    orderDirection = _props.orderDirection;

		return new SignTermsAccessor(id, {
			id: id, title: title, fields: fields, size: size, orderKey: orderKey, orderDirection: orderDirection
		});
	};

	SignTermsFilter.prototype.addFilter = function addFilter(option, level) {
		this.accessor.state = this.accessor.state.toggleLevel(level, option.key);
		this.searchkit.performSearch();
	};

	SignTermsFilter.prototype.renderOption = function renderOption(level, option) {
		var _this2 = this;

		var block = this.bemBlocks.option;
		var countFormatter = this.props.countFormatter;

		var className = block().state({
			selected: this.accessor.state.contains(level, option.key)
		});

		return React.createElement(
			"div",
			{ key: option.key },
			React.createElement(
				FastClick,
				{ handler: this.addFilter.bind(this, option, level) },
				React.createElement(
					"div",
					{ className: className },
					React.createElement(
						"div",
						{ className: block("text") },
						this.translate(option.key)
					),
					React.createElement(
						"div",
						{ className: block("count") },
						countFormatter(option.doc_count)
					)
				)
			),
			function () {
				if (_this2.accessor.resultsState.contains(level, option.key)) {
					return _this2.renderOptions(level + 1);
				}
			}()
		);
	};

	SignTermsFilter.prototype.renderOptions = function renderOptions(level) {
		var block = this.bemBlocks.container;
		return React.createElement(
			"div",
			{ className: block("hierarchical-options") },
			map(this.accessor.getBuckets(level), this.renderOption.bind(this, level))
		);
	};

	SignTermsFilter.prototype.render = function render() {
		var block = this.bemBlocks.container;
		var classname = block().mix("filter--" + this.props.id).state({
			disabled: this.accessor.getBuckets(0).length == 0
		});
		return React.createElement(
			"div",
			{ className: classname },
			React.createElement(
				"div",
				{ className: block("header") },
				this.props.title
			),
			React.createElement(
				"div",
				{ className: block("root") },
				this.renderOptions(0)
			)
		);
	};

	return SignTermsFilter;
}(SearchkitComponent), _class.defaultProps = {
	countFormatter: identity,
	size: 20
}, _class.propTypes = defaults({
	id: PropTypes.string.isRequired,
	fields: PropTypes.arrayOf(PropTypes.string).isRequired,
	title: PropTypes.string.isRequired,
	orderKey: PropTypes.string,
	orderDirection: PropTypes.oneOf(["asc", "desc"]),
	countFormatter: PropTypes.func
}, SearchkitComponent.propTypes), _temp);