"use strict";

exports.__esModule = true;
exports.AccessorBase = undefined;

var _searchkit = require("searchkit");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AccessorBase = exports.AccessorBase = function (_Accessor) {
    _inherits(AccessorBase, _Accessor);

    function AccessorBase(key, urlString) {
        _classCallCheck(this, AccessorBase);

        var _this = _possibleConstructorReturn(this, _Accessor.call(this));

        _this.key = key;
        _this.uuid = _this.key + _this.uuid;
        _this.urlKey = urlString || key && key.replace(/\./g, "_");
        _this.urlWithState = _this.urlWithState.bind(_this);
        return _this;
    }

    AccessorBase.prototype.onStateChange = function onStateChange(oldState) {};

    AccessorBase.prototype.fromQueryObject = function fromQueryObject(ob) {
        var value = ob[this.urlKey];
        this.state = this.state.setValue(value);
    };

    AccessorBase.prototype.getQueryObject = function getQueryObject() {
        var _ref;

        var val = this.state.getValue();
        return val ? (_ref = {}, _ref[this.urlKey] = val, _ref) : {};
    };

    AccessorBase.prototype.setSearchkitManager = function setSearchkitManager(searchkit) {
        _Accessor.prototype.setSearchkitManager.call(this, searchkit);
        this.setResultsState();
    };

    AccessorBase.prototype.setResults = function setResults(results) {
        _Accessor.prototype.setResults.call(this, results);
        this.setResultsState();
    };

    AccessorBase.prototype.setResultsState = function setResultsState() {
        this.resultsState = this.state;
    };

    AccessorBase.prototype.resetState = function resetState() {
        this.state = this.state.clear();
    };

    AccessorBase.prototype.urlWithState = function urlWithState(state) {
        var _searchkit$buildSearc;

        return this.searchkit.buildSearchUrl((_searchkit$buildSearc = {}, _searchkit$buildSearc[this.urlKey] = state, _searchkit$buildSearc));
    };

    return AccessorBase;
}(_searchkit.Accessor);